(*******************************************************************
This file was generated automatically by the Mathematica front end.
It contains Initialization cells from a Notebook file, which
typically will have the same name as this file except ending in
".nb" instead of ".m".

This file is intended to be loaded into the Mathematica kernel using
the package loading commands Get or Needs.  Doing so is equivalent
to using the Evaluate Initialization Cells menu command in the front
end.

DO NOT EDIT THIS FILE.  This entire file is regenerated
automatically each time the parent Notebook file is saved in the
Mathematica front end.  Any changes you make to this file will be
overwritten.
***********************************************************************)











(*  TContinuumMechanics is a Mathematica package that needs the package \
Tensorial 3.0  *)

(*  Author: Jean-Fran\[CCedilla]ois Gouyet  *)

(*  jean-francois.gouyet@polytechnique.fr *)

(*  I would appreciate any comments and your contributions are welcome to \
become part of TMecanica. *)

(* TContinuumMechanics can be used and distributed freely, 
  for non commercial purpose, 
always mentioning the author every time used as specified at Mathsource \
(www.mathsource.com)

 This software package and its accompanying documentation are provided \
without 
 guarantee of support or maintenance *)

(*  Mathematica is a registered trademark of Wolfram Research, Inc.     *)



BeginPackage["TContinuumMechanics1`TContinuumMechanics`",{"Graphics`Colors`",
    "TensorCalculus3`Tensorial`"}]





FlavorList::usage=
    "FlavorList[expr] gives the flavor of the terms listed in expr.";

SymmetricStandardOrder::usage=
    "SymmetricStandardOrder[x][expr] allows to order vertical couples \
{red@i,Void}, ... of indices, irrespective of their flavor, in a symmetric \
tensor x present in expr. Upper indices are ordered first in alphabetic order \
on the left, then lower indices. It has some common behaviour with \
SymmetrizeSlots to which it is complementary.It also orders symmetric tensors \
containing covariant derivatives.
    SymmetricStandardOrder[x,{ind}][expr] orders the first 'ind' symmetrical \
indices.
    SymmetricStandardOrder[x,{ind1,ind2}][expr] orders the symmetrical \
indices between columns 'ind1' and 'ind2'.";

CrossProductExpansion::usage=
    "CrossProductExpansion[BasisVectors,e][expr] expands three dimensional \
CrossProducts and Triple Scalar Products of Basis Vectors appearing in expr, \
into Levi-Civita tensors noted 'e'.";

LeviCivitaSimplify::usage=
    "LeviCivitaSimplify[e][expr] orders the indices in the Levi-Civita symbol \
'e', taking into account the signature of of the permutation, and asign to \
zero its covariant derivatives.";

BasisChange::usage=
    "BasisChange[\[Beta],toflavor][Tensor[T,list1,list2]] allows to perform \
the change via the transformation \[Beta], of an arbitrary tensor T in an \
initial flavor,to the final flavor 'toflavor'.";

LeviCivitaRule::usage=
    "LeviCivitaRule[e,\[Epsilon]][g,flavor] transforms the LeviCivita tensors \
e with down (resp. up) indices into the usual permutation symbol \[Epsilon] \
multiplied (resp. divided) by the square root on the elementary volume \
g[flavor] defined by the flavor basis. This rule is valid in any space \
dimension. (see http://mathworld.wolfram.com/permutationTensor.html)";

MetricTripleProduct::usage=
  "MetricTripleProduct[basis,metric,LeviCivita][expr] express any scalar \
triple products into combination of the components using Levi-Civita and \
metric tensors. Must not be confused with \!\(\*
  StyleBox[\"ScalarTripleProduct\",\nFontWeight->\"Bold\"]\) defined in the \
package Calculus`VectorAnalysis`";

PartialDSimplification::usage=
    "PartialDSimplification[expr] simplifies in expr the derivation of a \
tensor component by another component of the same tensor (the components must \
of course be independent).";

PartialDToDif::usage=
    "PartialDToDif[expr] rewrite the partial derivatives in their expanded \
form present in expr, into the partial derivatives with respect to the index \
of the coordinates.";
DifToPartialD::usage=
    "DifToPartialD[labels][expr] rewrite the partial derivatives with respect \
to coordinates indices present in , into the partial derivatives in their \
expanded form parametrized by labels.";

ChristoffeluSymbol::usage=
    "ChristoffeluSymbol[\[DoubleStruckE],\[CapitalGamma],k][expr] expressed \
the partial derivatives PartialD[Tensor[\[DoubleStruckE], {Void}, {i}],j] of \
basis vectors '\[DoubleStruckE]' on the basis using '\[CapitalGamma]'-noted \
Christoffel symbols with up indices; k is the dummy index of Einstein \
summation. We have chosen here to order the symmetrical Christoffel \
indices.";

ChristoffeldSymbol::usage=
    "ChristoffeldSymbol[\[DoubleStruckE],\[CapitalGamma],k][expr] expressed \
the partial derivatives PartialD[Tensor[\[DoubleStruckE], {Void}, {i}],j] of \
basis vectors '\[DoubleStruckE]' on the basis using '\[CapitalGamma]'-noted \
Christoffel symbols with down indices; k is the dummy index of Einstein \
summation. We have chosen here to order the symmetrical Christoffel indices.";

CovariantDSimplify::usage=
    "CovariantDSimplify[\[DoubleStruckE],g][expr] assign the value zero to \
Covariant derivatives of the basis vectors and the metric tensor.";

BasisDerivation::usage=
    "BasisDerivation[m][{\[DoubleStruckE],i},j][expr] expresses the partial \
derivative with respect to index j, of a basis vector \
Tensor[\[DoubleStruckE], {Void}, {i}] present in expr, into a combination of \
basis vectors. The coefficients are Christoffel symbols; m is a dummy index. \
The parameters are defined in labels = {x, \[Delta], g, \[CapitalGamma]}. \
This function includes the assignement to zero of the covariant derivative of \
basis vectors.
    BasisDerivation[h,m][{\[DoubleStruckE],i},{j,k}][expr] do the same kind \
of expansion for second partial derivatives. It includes the assignement to \
zero of the covariant derivatives of basis vectors.";

DifToCov::usage=
    "DifToCov[\[CapitalGamma],m][{u,i},j][expr] expresses the partial \
derivative with respect to index j, of a tensor u present in expr, into a \
combination of covariant derivative and components of u. The coefficients \
contain Christoffel symbols \[CapitalGamma] with m as a dummy index.
    DifToCov[\[CapitalGamma],m,h][{u,i},{j,k}][expr] do the same kind of \
expansion for second partial derivatives.";

TGrad::usage=
    "TGrad[\[DoubleStruckE],flavor@i][f] writes the gradient of a scalar \
tensor f, in the basis \[DoubleStruckE] with a defined flavor, and the dummy \
index i.";

TDiv::usage=
    "TDiv[\[DoubleStruckE],flavor@i][vector] writes the divergence of a \
vector field, in the basis \[DoubleStruckE] with a defined flavor, and the \
dummy index i.";

TCurl::usage=
    "TCurl[\[DoubleStruckE],flavor/@{i,j,k},e][vector] writes the curl of a \
vector field, in the basis \[DoubleStruckE] with a defined flavor, the dummy \
indices {i,j,k}, and the Levi-Civita symbol e.";

TLaplacian::usage=
    "TLaplacian[\[DoubleStruckE],flavor@i][f] writes the laplacian of a \
scalar tensor f, in the basis \[DoubleStruckE] with a defined flavor, and the \
dummy index i.";

TensorNesting::usage=
    "TensorNesting[expr] reduces successive derivatives in expr leading to \
Tensor[Tensor[...],...] nested forms, into canonical tensor expressions \
Tensor[...]..";

TensorUnNesting::usage=
  "TensorUnNesting[expr] writes covariant or partial derivatives in expr, of \
the form Tensor[T,\!\(\*
  StyleBox[\"{\",\nFontSize->14]\)\!\(\*
  StyleBox[\"...\",\nFontSize->14]\)\!\(\*
  StyleBox[\",\",\nFontSize->14]\)\!\(\*
  StyleBox[\"Void\",\nFontSize->14]\)\!\(\*
  StyleBox[\"}\",\nFontSize->14]\)\!\(\*
  StyleBox[\",\",\nFontSize->14]\)\!\(\*
  StyleBox[\"{\",\nFontSize->14]\)\!\(\*
  StyleBox[\"...\",\nFontSize->14]\)\!\(\*
  StyleBox[\",\",\nFontSize->14]\)\!\(\*
  StyleBox[\"Cov\",\nFontSize->14]\)\!\(\*
  StyleBox[\"[\",\nFontSize->14]\)\!\(\*
  StyleBox[\"index\",\nFontSize->14]\)\!\(\*
  StyleBox[\"]\",\nFontSize->14]\)\!\(\*
  StyleBox[\"}\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"into\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"unnested\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"expressions\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"of\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"the\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"form\",\nFontSize->14]\)\!\(\*
  StyleBox[\" \",\nFontSize->14]\)\!\(\*
  StyleBox[\"Tensor\",\nFontSize->14]\)\!\(\*
  StyleBox[\"[\",\nFontSize->14]\)Tensor[...],{Void},{Cov[index]}] alowing to \
make replacements acting on the tensor Tensor[T,...] before derivation. \
TTensorNesting is then used to reestablish the canonical tensor form";



Begin["`Private`"]



FlavorList[expr_]:=
  Module[{n$,FlavorVal},
    Table[(expr[[n$]]/.Tensor[u_,{x_},{y_}]\[RuleDelayed]
            If[Head@x=!=Symbol,FlavorVal=Head@x,
              If[Head@y=!=Symbol,FlavorVal=Head@y,FlavorVal=Identity]];
        FlavorVal),{n$,Length[expr]}]]

SymmetricStandardOrder[x_][expr_]:=
  expr/.Tensor[x,ups_,downs_]\[RuleDelayed]
      Module[{ii,iii,indices,updowns1,RawIndexupdowns1,updowns2,
            RawIndexupdowns2,
            siteCov},{siteCov=
              Table[{ii},{ii,
                  Length[ups]-Length[Position[{ups,downs},Cov[_]]]+1,
                  Length[ups]}];
            
            updowns1=({ups,downs}/.{Void\[Rule]\[Sharp],Cov\[Rule]Identity}//
                  Transpose);
            
            RawIndexupdowns1=(Table[
                  RawIndex/@(updowns1[[ii]]),{ii,Length[updowns1]}]);
            RawIndexupdowns2=Sort[RawIndexupdowns1];
            Off[RawIndex::"notindex"];
            
            updowns2=
              Permutations[updowns1][[ 
                  Position[RawIndex//@Permutations[updowns1],
                      RawIndexupdowns2][[1,1]] ]];On[RawIndex::"notindex"];
            
            indices=Transpose[
                MapAt[Cov,updowns2,
                      siteCov]/.{Cov@{i_,j_}\[Rule]{Cov@i,
                          Cov@j}}/.{Cov@\[Sharp]\[Rule]Void,\[Sharp]\[Rule]
                      Void}];
            Tensor[x,indices[[1]],indices[[2]]]}][[1]]

SymmetricStandardOrder[x_,{ind_}][expr_]:=
  expr/.Tensor[x,ups_,downs_]\[RuleDelayed]
      Module[{ii,iii,indices,updowns1,RawIndexupdowns1,updowns2,
            RawIndexupdowns2,
            siteCov},{siteCov=
              Table[{ii},{ii,
                  Length[ups]-Length[Position[{ups,downs},Cov[_]]]+1,
                  Length[ups]}];
            
            updowns1=({ups,downs}/.{Void\[Rule]\[Sharp],Cov\[Rule]Identity}//
                  Transpose);
            
            RawIndexupdowns1=(Table[
                  RawIndex/@(updowns1[[ii]]),{ii,Length[updowns1]}]);
            
            RawIndexupdowns2=(Flatten[{Sort[Take[RawIndexupdowns1,ind]],
                    Take[RawIndexupdowns1,{ind+1,Length[updowns1]}]},1]);
            Off[RawIndex::"notindex"];
            
            updowns2=
              Permutations[updowns1][[ 
                  Position[RawIndex//@Permutations[updowns1],
                      RawIndexupdowns2][[1,1]] ]];On[RawIndex::"notindex"];
            
            indices=Transpose[
                MapAt[Cov,updowns2,
                      siteCov]/.{Cov@{i_,j_}\[Rule]{Cov@i,
                          Cov@j}}/.{Cov@\[Sharp]\[Rule]Void,\[Sharp]\[Rule]
                      Void}];
            Tensor[x,indices[[1]],indices[[2]]]}][[1]]

SymmetricStandardOrder[x_,{ind1_,ind2_}][expr_]:=
  expr/.Tensor[x,ups_,downs_]\[RuleDelayed]
      Module[{ii,iii,indices,updowns1,RawIndexupdowns1,updowns2,
            RawIndexupdowns2,
            siteCov},{siteCov=
              Table[{ii},{ii,
                  Length[ups]-Length[Position[{ups,downs},Cov[_]]]+1,
                  Length[ups]}];
            
            updowns1=({ups,downs}/.{Void\[Rule]\[Sharp],Cov\[Rule]Identity}//
                  Transpose);
            
            RawIndexupdowns1=(Table[
                  RawIndex/@(updowns1[[ii]]),{ii,Length[updowns1]}]);
            
            RawIndexupdowns2=(Flatten[{Take[RawIndexupdowns1,ind1-1],
                    Sort[Take[RawIndexupdowns1,{ind1,ind2}]],
                    Take[RawIndexupdowns1,{ind2+1,Length[updowns1]}]},1]);
            Off[RawIndex::"notindex"];
            
            updowns2=
              Permutations[updowns1][[ 
                  Position[RawIndex//@Permutations[updowns1],
                      RawIndexupdowns2][[1,1]] ]];On[RawIndex::"notindex"];
            
            indices=Transpose[
                MapAt[Cov,updowns2,
                      siteCov]/.{Cov@{i_,j_}\[Rule]{Cov@i,
                          Cov@j}}/.{Cov@\[Sharp]\[Rule]Void,\[Sharp]\[Rule]
                      Void}];
            Tensor[x,indices[[1]],indices[[2]]]}][[1]]

CrossProductExpansion[\[DoubleStruckE]_,e_,k$_][expr_]:=expr/.
      {Tensor[\[DoubleStruckE],{i_},{Void}]\[Cross]
              Tensor[\[DoubleStruckE],{j_},{Void}].Tensor[\[DoubleStruckE],{k_\
},{Void}]\[RuleDelayed]Tensor[e,{i,j,k},{Void,Void,Void}],
        Tensor[\[DoubleStruckE],{i_},{Void}]\[Cross]
              Tensor[\[DoubleStruckE],{j_},{Void}].Tensor[\[DoubleStruckE],{\
Void},{k_}]\[RuleDelayed]Tensor[e,{i,j,Void},{Void,Void,k}],
        Tensor[\[DoubleStruckE],{i_},{Void}]\[Cross]
              Tensor[\[DoubleStruckE],{Void},{j_}].Tensor[\[DoubleStruckE],{k_\
},{Void}]\[RuleDelayed]Tensor[e,{i,Void,k},{Void,j,Void}],
        Tensor[\[DoubleStruckE],{i_},{Void}]\[Cross]
              Tensor[\[DoubleStruckE],{Void},{j_}].Tensor[\[DoubleStruckE],{\
Void},{k_}]\[RuleDelayed]Tensor[e,{i,Void,Void},{Void,j,k}],
        Tensor[\[DoubleStruckE],{Void},{i_}]\[Cross]
              Tensor[\[DoubleStruckE],{j_},{Void}].Tensor[\[DoubleStruckE],{\
Void},{k_}]\[RuleDelayed]Tensor[e,{Void,j,Void},{i,Void,k}],
        Tensor[\[DoubleStruckE],{Void},{i_}]\[Cross]
              Tensor[\[DoubleStruckE],{j_},{Void}].Tensor[\[DoubleStruckE],{k_\
},{Void}]\[RuleDelayed]Tensor[e,{Void,j,k},{i,Void,Void}],
        Tensor[\[DoubleStruckE],{Void},{i_}]\[Cross]
              Tensor[\[DoubleStruckE],{Void},{j_}].Tensor[\[DoubleStruckE],{k_\
},{Void}]\[RuleDelayed]Tensor[e,{Void,Void,k},{i,j,Void}],
        Tensor[\[DoubleStruckE],{Void},{i_}]\[Cross]
              Tensor[\[DoubleStruckE],{Void},{j_}].Tensor[\[DoubleStruckE],{\
Void},{k_}]\[RuleDelayed]Tensor[e,{Void,Void,Void},{i,j,k}],
        
        Tensor[\[DoubleStruckE],{Void},{i_}]\[Cross]
            Tensor[\[DoubleStruckE],{j_},{Void}]\[RuleDelayed]
          If[Head[i]=!=Symbol ,
            If[Head[i]===Head[j],
              Tensor[e,{Void,j,Void},{i,Void,
                    Head[i][k$]}] Tensor[\[DoubleStruckE],{Head[i][
                      k$]},{Void}],
              Print[Head[i],"Error : not in the same flavor"]],
            Tensor[e,{Void,j,Void},{i,Void,
                  k$}] Tensor[\[DoubleStruckE],{k$},{Void}]],
        Tensor[\[DoubleStruckE],{i_},{Void}]\[Cross]
            Tensor[\[DoubleStruckE],{Void},{j_}]\[RuleDelayed]
          If[Head[i]=!=Symbol,
            If[Head[i]===Head[j],
              Tensor[e,{i,Void,Head[i][k$]},{Void,j,
                    Void}] Tensor[\[DoubleStruckE],{Void},{Head[i][k$]}],
              Print[Head[i],"Error : not in the same flavor"]],
            Tensor[e,{i,Void,k$},{Void,j,
                  Void}] Tensor[\[DoubleStruckE],{Void},{k$}]],
        Tensor[\[DoubleStruckE],{Void},{i_}]\[Cross]Tensor[\[DoubleStruckE],{\
Void},{j_}]\[RuleDelayed]If[Head[i]=!=Symbol,
            If[Head[i]===Head[j],
              Tensor[e,{Void,Void,Void},{i,j,
                    Head[i][k$]}] Tensor[\[DoubleStruckE],{Head[i][
                      k$]},{Void}],
              Print[Head[i],"Error : not in the same flavor"]],
            Tensor[e,{Void,Void,Void},{i,j,
                  k$}] Tensor[\[DoubleStruckE],{k$},{Void}]],
        Tensor[\[DoubleStruckE],{i_},{Void}]\[Cross]Tensor[\[DoubleStruckE],{\
j_},{Void}]\[RuleDelayed]If[Head[i]=!=Symbol,
            If[Head[i]===Head[j],
              Tensor[e,{i,j,Head[i][k$]},{Void,Void,
                    Void}] Tensor[\[DoubleStruckE],{Void},{Head[i][k$]}],
              Print[Head[i],"Error : not in the same flavor"]],
            Tensor[e,{i,j,k$},{Void,Void,
                  Void}] Tensor[\[DoubleStruckE],{Void},{k$}]]}/.{Tensor[
          e,{i_,j_,k_},{Void,Void,Void}]:>0/;((i==j) || (j==k) || (k==i)),
      Tensor[e,{Void,Void,Void},{i_,j_,k_}]:>0/;((i==j) || (j==k) || (k==i))}

LeviCivitaSimplify[e_][expr_]:=
  expr/.{Tensor[e,{i_,j_,k_},{Void,Void,Void}]:>
        Signature[{i,j,k}]Tensor[e,Sort[{i,j,k}],{Void,Void,Void}],
      Tensor[e,{Void,Void,Void},{i_,j_,k_}]:>
        Signature[{i,j,k}]Tensor[e,{Void,Void,Void},Sort[{i,j,k}]],
      Tensor[e,{i_,j_,k_,Void},{Void,Void,Void,Cov[h_]}]\[RuleDelayed]0,
      Tensor[e,{Void,Void,Void,Void},{i_,j_,k_,Cov[h_]}]\[RuleDelayed]0,
      Tensor[e,{i_,j_,k_,Void,__},{Void,Void,Void,Cov[h_],__}]\[RuleDelayed]0,
      Tensor[e,{Void,Void,Void,Void,__},{i_,j_,k_,Cov[h_],__}]\[RuleDelayed]0}

BasisChange[\[Beta]_,toflavor_][Tensor[T_,list1_,list2_]]:=
  Module[{ii},
      Tensor[T,list1,list2]Product[
          If[list2[[ii]]===Void,
            Tensor[\[Beta],
              toflavor[#]&/@{list2[[ii]],list1[[ii]]},{list1[[ii]],
                list2[[ii]]}],
            Tensor[\[Beta],{list2[[ii]],list1[[ii]]},
              toflavor[#]&/@{list1[[ii]],list2[[ii]]}]],{ii,
            Length[list1]}]]/.{toflavor[Void]->Void,
      toflavor[f_[i_]]->toflavor[i]}
BasisChange[\[Beta]_,toflavor_][ff_[x_]]:=
  ff[BasisChange[\[Beta],toflavor][x]]
BasisChange[\[Beta]_,toflavor_][ff_[x_,y_]]:=
  ff[BasisChange[\[Beta],toflavor][x],y]
BasisChange[\[Beta]_,toflavor_][x_+y_]:=
  BasisChange[\[Beta],toflavor][x]+BasisChange[\[Beta],toflavor][y]
BasisChange[\[Beta]_,toflavor_][a_. x_Tensor]:=
  a BasisChange[\[Beta],toflavor][x]

LeviCivitaRule[e_,\[Epsilon]_][g_,flavor_]:=
  Tensor[e,list1_,list2_]:>
    If[list1===Table[Void,{ii,Length[list1]}],
      Sqrt[g[flavor]]Tensor[\[Epsilon],list1,list2],
      If[list2===Table[Void,{ii,Length[list2]}],
        1/Sqrt[g[flavor]]Tensor[\[Epsilon],list1,list2]],Print["Error"]]

MetricTripleProduct[basis_,metric_,LeviCivita_,k_][
    expr_]:=(expr//
            LinearBreakout[Cross][Tensor[basis,{_},{Void}],
              Tensor[basis,{Void},{_}]])//
        CrossProductExpansion[basis,LeviCivita,k]//
      LinearBreakout[Dot][Tensor[basis,{_},{Void}],Tensor[basis,{Void},{_}]]//
    EvaluateDotProducts[basis,metric,False]

PartialDSimplification[g_][expr_]:=
  expr/.PartialD[Tensor[t_,{ups1__},{downs1__}],
        Tensor[t_,{ups2__},{downs2__}]]:>(If[
          Length[{ups1}]==Length[{ups2}] && 
            Length[{downs1}]==Length[{downs2}],
          Product[Tensor[g,{{ups1}[[i$]],{downs2}[[i$]]},{Void,Void}],{i$,
                  Length[{ups1}]}]Product[
                Tensor[g,{{ups1}[[i$]],Void},{Void,{ups2}[[i$]]}],{i$,
                  Length[{ups1}]}]Product[
                Tensor[g,{{downs2}[[i$]],Void},{Void,{downs1}[[i$]]}],{i$,
                  Length[{ups1}]}]Product[
                Tensor[g,{Void,Void},{{ups2}[[i$]],{downs1}[[i$]]}],{i$,
                  Length[{ups1}]}]/.{Tensor[g,{i_,Void},{Void,Void}]->1,
              Tensor[g,{Void,i_},{Void,Void}]->1,
              Tensor[g,{Void,Void},{i_,Void}]->1,
              Tensor[g,{Void,Void},{Void,i_}]->1},0])

PartialDToDif[expr_]:=
  expr/.PartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][Tensor[var__],i_]:>
      PartialD[Tensor[var],(i/.Tensor[x,{j_},{Void}]\[Rule]j)]

DifToPartialD[{x_,\[Delta]_,g_,\[CapitalGamma]_}][expr_]:=
  expr/.Tensor[var_,i_,j_]\[RuleDelayed](ord=Count[j,Dif[k_]];
        PartialD[{x,\[Delta],g,\[CapitalGamma]}][
          Tensor[var,Drop[i,-ord],
            Drop[j,-ord]],(Take[j,-ord]/.Dif[l_]\[Rule]Tensor[x,{l},{Void}])])

ChristoffeluSymbol[\[DoubleStruckE]_,\[CapitalGamma]_,k_][expr_]:=
  expr/.{PartialD[Tensor[\[DoubleStruckE], {Void}, {i_}],j_]:>
        If[Head[i]===Symbol,
          Tensor[\[DoubleStruckE], {Void}, {k}]Tensor[\[CapitalGamma],{k,Void,
                Void},Flatten[{Void,Sort[{i,j}]}]],
          Tensor[\[DoubleStruckE],{Void},{Head[i]@
                  k}]Tensor[\[CapitalGamma],{Head[i]@k,Void,Void},
              Flatten[{Void,Sort[{i,j}]}]]],
      PartialD[Tensor[\[DoubleStruckE], {i_}, {Void}],j_]:>
        If[Head[i]===
            Symbol,-Tensor[\[DoubleStruckE], {k}, {Void}]Tensor[\
\[CapitalGamma],{i,Void,Void},
              Flatten[{Void,
                  Sort[{j,k}]}]],-Tensor[\[DoubleStruckE],{Head[i]@
                    k},{Void}]Tensor[\[CapitalGamma],{i,Void,Void},
              Flatten[{Void,Sort[{j,Head[i]@k}]}]]]}

ChristoffeldSymbol[\[DoubleStruckE]_,\[CapitalGamma]_,k_][expr_]:=
  expr/.{PartialD[Tensor[\[DoubleStruckE], {Void}, {i_}],j_]:>
        If[Head[i]===Symbol,
          Tensor[\[DoubleStruckE], {k}, {Void}]Tensor[\[CapitalGamma],{Void,
                Void,Void},Flatten[{k,Sort[{i,j}]}]],
          Tensor[\[DoubleStruckE],{Head[i]@
                  k},{Void}]Tensor[\[CapitalGamma],{Void,Void,Void},
              Flatten[{Head[i]@k,Sort[{i,j}]}]]]}

CovariantDSimplify[\[DoubleStruckE]_,g_][expr_]:=expr/.{
      CovariantD[Tensor[\[DoubleStruckE], {Void}, {i_}],j_]:>
        If[Head[i]==Head[j],0],
      CovariantD[Tensor[\[DoubleStruckE],  {i_},{Void}],j_]:>
        If[Head[i]==Head[j],0],
      CovariantD[Tensor[g, {Void,Void}, {i_,j_}],k_]:>
        If[Head[i]==Head[j]==Head[k],0],
      CovariantD[Tensor[g,{Void,j_},{i_,Void}],k_]:>
        If[Head[i]==Head[j]==Head[k],0],
      CovariantD[Tensor[g,{i_,Void},{Void,j_}],k_]:>
        If[Head[i]==Head[j]==Head[k],0],
      CovariantD[Tensor[g,{i_,j_},{Void,Void}],k_]:>
        If[Head[i]==Head[j]==Head[k],0]}

BasisDerivation[\[CapitalGamma]_,m_][{\[DoubleStruckE]_,i_},j_][expr_]:=
  expr/.{Tensor[\[DoubleStruckE],{Void,Void},{i,Dif[j]}]\[Rule]
        Tensor[\[DoubleStruckE],{Void},{m}]*
          Tensor[\[CapitalGamma],{m,Void,Void},{Void,j,i}],
      Tensor[\[DoubleStruckE],{i,Void},{Void,
            Dif[j]}]\[Rule]-(Tensor[\[DoubleStruckE],{m},{Void}]*
              Tensor[\[CapitalGamma],{i,Void,Void},{Void,j,m}]),
      Tensor[\[DoubleStruckE],{Void,Void},{i,Cov[j]}]\[RuleDelayed]
        If[Head[i]\[Equal]Head[j],0],
      Tensor[\[DoubleStruckE],{i,Void},{Void,Cov[j]}]\[RuleDelayed]
        If[Head[i]\[Equal]Head[j],0]}

BasisDerivation[\[CapitalGamma]_,h_,m_][{\[DoubleStruckE]_,i_},{j_,k_}][
    expr_]:=expr/.{Tensor[\[DoubleStruckE],{Void,Void,Void},{i,Dif[j],
            Dif[k]}]\[Rule]
        Tensor[\[DoubleStruckE],{Void},{h}]*(Tensor[\[CapitalGamma],{h,Void,
                    Void},{Void,k,m}]*
                Tensor[\[CapitalGamma],{m,Void,Void},{Void,j,i}]+
              Tensor[\[CapitalGamma],{h,Void,Void,Void},{Void,j,i,Dif[k]}]),
      Tensor[\[DoubleStruckE],{i,Void,Void},{Void,Dif[j],Dif[k]}]\[Rule]
        Tensor[\[DoubleStruckE],{h},{Void}]*(Tensor[\[CapitalGamma],{i,Void,
                    Void},{Void,j,m}]*
                Tensor[\[CapitalGamma],{m,Void,Void},{Void,k,h}]-
              Tensor[\[CapitalGamma],{i,Void,Void,Void},{Void,j,h,Dif[k]}]),
      Tensor[\[DoubleStruckE],{Void,Void,__},{i,Cov[j],__}]\[RuleDelayed]
        If[Head[i]\[Equal]Head[j],0],
      Tensor[\[DoubleStruckE],{i,Void,__},{Void,Cov[j],__}]\[RuleDelayed]
        If[Head[i]\[Equal]Head[j],0]}

DifToCov[\[CapitalGamma]_,m_][{u_,i_},j_][expr_]:= 
  expr/.{Tensor[u,{i,Void},{Void,Dif[j]}]:>
        Tensor[u,{i,Void},{Void,Cov[j]}]-
          Tensor[u,{m},{Void}]Tensor[\[CapitalGamma],{i,Void,Void},{Void,j,
                m}],Tensor[u,{Void,Void},{i,Dif[j]}]:>
        Tensor[u,{Void,Void},{i,Cov[j]}]+
          Tensor[u,{Void},{m}]Tensor[\[CapitalGamma],{m,Void,Void},{Void,i,
                j}]}

DifToCov[\[CapitalGamma]_,m_,h_][{u_,i_},{j_,k_}][expr_]:= 
  expr/.{Tensor[u,{Void,Void,Void},{i,Dif[j],Dif[k]}]\[Rule]
        Tensor[u,{Void,Void,Void},{i,Cov[j],Cov[k]}]+
          Tensor[u,{Void,Void},{h,Cov[j]}]*
            Tensor[\[CapitalGamma],{h,Void,Void},{Void,i,k}]+
          Tensor[u,{Void,Void},{i,Cov[h]}]*
            Tensor[\[CapitalGamma],{h,Void,Void},{Void,j,k}]+
          Tensor[u,{Void,Void},{m,Cov[k]}]*
            Tensor[\[CapitalGamma],{m,Void,Void},{Void,i,j}]+
          Tensor[u,{Void},{h}]*
            Tensor[\[CapitalGamma],{h,Void,Void},{Void,k,m}]*
            Tensor[\[CapitalGamma],{m,Void,Void},{Void,i,j}]+
          Tensor[u,{Void},{m}]*
            Tensor[\[CapitalGamma],{m,Void,Void,Void},{Void,i,j,Dif[k]}],
      Tensor[u,{i,Void,Void},{Void,Dif[j],Dif[k]}]\[Rule]
        Tensor[u,{i,Void,Void},{Void,Cov[j],Cov[k]}]+
          Tensor[u,{i,Void},{Void,Cov[h]}]*
            Tensor[\[CapitalGamma],{h,Void,Void},{Void,j,k}]-
          Tensor[u,{h,Void},{Void,Cov[j]}]*
            Tensor[\[CapitalGamma],{i,Void,Void},{Void,h,k}]-
          Tensor[u,{m,Void},{Void,Cov[k]}]*
            Tensor[\[CapitalGamma],{i,Void,Void},{Void,j,m}]+
          Tensor[u,{h},{Void}]*
            Tensor[\[CapitalGamma],{i,Void,Void},{Void,j,m}]*
            Tensor[\[CapitalGamma],{m,Void,Void},{Void,h,k}]-
          Tensor[u,{m},{Void}]*
            Tensor[\[CapitalGamma],{i,Void,Void,Void},{Void,j,m,Dif[k]}]}

TGrad[\[DoubleStruckE]_,flavor_@i_][f_]:=
  Module[{i$},
    CovariantD[f,
          flavor@i$]Tensor[\[DoubleStruckE],{flavor@i$},{Void}]/.i$\[Rule]i]
TGrad[\[DoubleStruckE]_,i_][f_]:=
  If[Head@i\[Equal]Symbol,
    Module[{i$},
      CovariantD[f,i$]Tensor[\[DoubleStruckE],{i$},{Void}]/.i$\[Rule]i]]

TDiv[\[DoubleStruckE]_,g_,flavor_@i_][vector_]:=
  Module[{i$},
    CovariantD[
        vector.Tensor[\[DoubleStruckE],{flavor@i$},{Void}]//
          EvaluateDotProducts[\[DoubleStruckE],g],flavor@i$]/.i$\[Rule]i]
TDiv[\[DoubleStruckE]_,g_,i_][vector_]:=
  If[Head@i\[Equal]Symbol,
    Module[{i$},
      CovariantD[
          vector.Tensor[\[DoubleStruckE],{i$},{Void}]//
            EvaluateDotProducts[\[DoubleStruckE],g],i$]/.i$\[Rule]i]]

TCurl[\[DoubleStruckE]_,g_,flavor_/@{i_,j_,k_},e_][vector_]:=
  Module[{i$,j$,k$},
    CovariantD[
          vector.Tensor[\[DoubleStruckE],{Void},{flavor@j$}]//
            EvaluateDotProducts[\[DoubleStruckE],g],
          flavor@i$]Tensor[\[DoubleStruckE],{Void},{flavor@k$}]Tensor[
          e,{flavor@i$,flavor@j$,flavor@k$},{Void,Void,Void}]/.{i$\[Rule]i,
        j$\[Rule]j,k$\[Rule]k}]
TCurl[\[DoubleStruckE]_,g_,{i_,j_,k_},e_][vector_]:=
  If[Head@i &&Head@i &&Head@i\[Equal]Symbol,
    Module[{i$,j$,k$},
      CovariantD[
            vector.Tensor[\[DoubleStruckE],{Void},{j$}]//
              EvaluateDotProducts[\[DoubleStruckE],g],
            i$]Tensor[\[DoubleStruckE],{Void},{k$}]Tensor[
            e,{i$,j$,k$},{Void,Void,Void}]/.{i$\[Rule]i,j$\[Rule]j,
          k$\[Rule]k}]]


TLaplacian[\[DoubleStruckE]_,g_,i_,j_][f_]:=
  TDiv[\[DoubleStruckE],g,i][TGrad[\[DoubleStruckE],j][f]]//Expand//
      CovariantDSimplify[\[DoubleStruckE],g]//MetricSimplify[g]

TensorUnNesting[T_][expr_]:=
  expr//.If[Head[a]=!=Tensor,
      Tensor[a_. Tensor[T,{ups1__},{downs1__}],{ups2__},{downs2__}]\[Rule]
        a Tensor[T,Join[{ups1},{ups2}],Join[{downs1},{downs2}]],expr]

TensorNesting[T_][expr_]:=
  expr/.{Tensor[T,{ups1__,Void},{downs1__,Cov[i_]}]->
        Tensor[Tensor[T,{ups1},{downs1}],{Void},{Cov[i]}],
      Tensor[T,{ups1__,Void},{downs1__,Dif[i_]}]->
        Tensor[Tensor[T,{ups1},{downs1}],{Void},{Dif[i]}],
      Tensor[T,{ups1__,Cov[i_]},{downs1__,Void}]->
        Tensor[Tensor[T,{ups1},{downs1}],{Cov[i]},{Void}],
      Tensor[T,{ups1__,Dif[i_]},{downs1__,Void}]->
        Tensor[Tensor[T,{ups1},{downs1}],{Dif[i]},{Void}]}



End[]

EndPackage[]